<div :class="get_bg_text('form-center mb-5')">
  <form class="mb-0">
    <!-- <div v-if="metalInfo.isAdmin && path=='admin'" class="d-flex flex-column"> -->
    <!--   <div class="form-group border border-info"> -->
    <!--     <label class="w-100 text-center" for="delAddr">Delegate Address</label> -->
    <!--     <b-form-input -->
    <!--       v-model="form.addr" -->
    <!--       type="text" -->
    <!--       size="lg" -->
    <!--       :class="get_bg('border-0')" -->
    <!--       id="delAddr" -->
    <!--       placeholder="dn1..."> -->
    <!--     </b-form-input> -->
    <!--   </div> -->
    <!--   <b-button v-if="isMetalReady" -->
    <!--             :disabled="injected!=undefined" pill size="lg" class="my-2 my-sm-0 p-3" -->
    <!--             @click="set_delegate()" variant="primary"> -->
    <!--     Set Delegate -->
    <!--   </b-button> -->

    <!--   <div class="form-group border border-info text-center mt-3"> -->
    <!--     <b-form-checkbox -->
    <!--       id="checkbox-1" -->
    <!--       v-model="form.blocked" -->
    <!--       name="checkbox-1" -->
    <!--       value="storage.blocked" -->
    <!--       unchecked-value="false" -->
    <!--       size="lg"> -->
    <!--       Blocked -->
    <!--     </b-form-checkbox> -->
    <!--   </div> -->
    <!--   <b-button v-if="isMetalReady" -->
    <!--             :disabled="injected!=undefined" pill size="lg" class="my-2 my-sm-0 p-3" -->
    <!--             @click="set_blocked()" variant="primary"> -->
    <!--     Set Blocked -->
    <!--   </b-button> -->

    <!-- </div> -->

    <div class="d-flex flex-column">

      <template v-if="path=='deposit'">
        <div class="form-group border border-info">
          <label class="w-100 text-center" for="amountDun">
            Amount (minimum 1000 &#x0111;)
            <b-badge
              v-b-modal.modal-deposit href="#" variant="info" class="small align-top">
              ?
            </b-badge>
          </label>
          <b-form-input
            v-model="form.amount"
            type="number"
            step="0.01"
            min="0"
            :max="metalInfo.balanceDunUnit - 1"
            size="lg"
            :class="get_bg('border-0')"
            id="amountDun"
            placeholder="0"
            value="0">
          </b-form-input>

          <b-form-input
            v-model="form.amount"
            type="range"
            step="0.01"
            min="0"
            :max="metalInfo.balanceDunUnit - 1"
            size="sm"
            class="get_bg('border-0 bt-2')"
            id="amountDunRange">
          </b-form-input>
          <div
            :style="{visibility: form.amount!=undefined && form.amount!='0' ? 'visible' : 'hidden'}"
            class="small muted text-right" >
            <span class="mr-1">Crystals allocation</span>
            <v-dun-ton precision="2" :amount="form.amount">
            </v-dun-ton>
          </div>
        </div>

        <div class="form-group border border-info">
          <label class="w-100 text-center" for="toAddr">
            Return Address
            <b-badge
              v-b-modal.modal-deposit href="#" variant="info" class="small align-top">
              ?
            </b-badge>
          </label>
          <b-form-input
            v-model="form.addr"
            type="text"
            size="lg"
            :class="get_bg('border-0')"
            id="toAddr"
            placeholder="Dune Address in case of refund">
          </b-form-input>
        </div>

        <div class="form-group border border-info">
          <label class="w-100 text-center" for="ftAddr">
            Free TON Address
            <b-badge
              v-b-modal.modal-deposit href="#" variant="info" class="small align-top">
              ?
            </b-badge>
          </label>
          <b-form-input
            v-model="form.freeTONAddr"
            type="text"
            size="lg"
            :class="get_bg('border-0')"
            id="ftAddr"
            placeholder="Recipient of Free TON tokens">
          </b-form-input>
        </div>

        <div class="form-group border border-info">
          <label class="w-100 text-center" for="ftpk">
            Free TON Pubkey
            <b-badge
              v-b-modal.modal-deposit href="#" variant="info" class="small align-top">
              ?
            </b-badge>
          </label>
          <b-form-input
            v-model="form.freeTONPubkey"
            type="text"
            size="lg"
            :class="get_bg('border-0')"
            id="ftpk"
            placeholder="The public key of the recipient on Free TON">
          </b-form-input>
        </div>

        <div class="form-group border border-info">
          <label class="w-100 text-center" for="sec">
            Swap Secret
            <b-badge
              v-b-modal.modal-deposit href="#" variant="info" class="small align-top">
              ?
            </b-badge>
          </label>
          <b-form-input
            v-model="form.secret"
            type="text"
            size="lg"
            :class="get_bg('border-0')"
            id="sec"
            placeholder="Pick a strong secret">
          </b-form-input>
        </div>

      </template>

      <template v-else-if="path=='reveal'">

        <v-swap :storage="storage" :currentSwap="currentSwap"></v-swap>

        <div class="form-group border border-info">

          <label class="w-100 text-center" for="secret">
            Secret
            <b-badge
              v-b-modal.modal-swap href="#" variant="info" class="small align-top">
              ?
            </b-badge>
          </label>
          <b-form-input
            v-model="form.secret"
            type="text"
            size="lg"
            :class="get_bg('border-0')"
            id="secret"
            placeholder="Secret used during deposit">
          </b-form-input>
        </div>

        <b-button
          pill
          :disabled="injected!=undefined"
          size="lg"
          class="my-2 my-sm-0 p-3 flex-fill"
          @click="relay_reveal()"
          variant="primary">
          Reveal with the relay
        </b-button>
        <span class="flex-fill text-center my-1">or</span>
        <b-button
          pill
          :disabled="injected!=undefined"
          size="lg"
          class="my-2 my-sm-0 p-3 flex-fill"
          @click="ton_client_reveal()"
          variant="warning">
          Use FreeTON CLI
        </b-button>

      </template>

      <template v-else-if="path=='refund'">

        <v-swap :storage="storage" :currentSwap="currentSwap"></v-swap>

      </template>

      <template v-if="isMetalReady">
        <template v-if="path=='deposit'">
          <!--
          <b-button
            :disabled="injected!=undefined" pill size="lg" class="my-2 my-sm-0 p-3"
            @click="deposit_reveal()" variant="info">
            Deposit with Automatic Secret Revelation
            <span
              id="tt-auto"
              class="border rounded-circle px-1 align-top"
              style="font-size:0.5em;">
              ?
            </span>
            <b-tooltip target="tt-auto" triggers="hover">
              <div>
                The secret will be revealed by the relays as soon as possible.
                The swap will be confirmed after few confirmations on each chains
              </div>
            </b-tooltip>
          </b-button>
          <span class="flex-fill text-center my-1">or</span>
-->
          <b-button
            :disabled="injected!=undefined" pill size="lg" class="my-2 my-sm-0 p-3"
            @click="deposit()" variant="primary">
            Start a Swap
            <span
              id="tt-manual"
              class="border rounded-circle px-1 align-top"
              style="font-size:0.5em;">
              ?
            </span>
            <b-tooltip target="tt-manual" triggers="hover">
              <div>
                You will need to manualy trigger the revelation of the secret (using this dapp or a command line client)
              </div>
              <b>Do not forget your secret!</b>
            </b-tooltip>
          </b-button>
        </template>
        <b-button v-else-if="path=='refund'"
                  :disabled="injected!=undefined" pill size="lg" class="my-2 my-sm-0 p-3"
                  @click="refund()" variant="primary">
          Refund
        </b-button>
      </template>

      <template v-else>
        <template v-if="path!=='reveal'">
          <b-button
            pill
            size="lg"
            class="flex-fill my-2 my-sm-0 p-3"
            :variant="get_outline()"
            @click="update_metal">
            Connect Metal
          </b-button>
          <span class="flex-fill text-center my-1">or</span>
          <b-button
            v-if="path=='deposit'"
            pill
            :disabled="injected!=undefined"
            size="lg"
            class="my-2 my-sm-0 p-3 flex-fill"
            @click="dune_client_deposit()"
            variant="warning">
            Use client
          </b-button>
          <b-button
            v-else-if="path=='refund'"
            pill
            :disabled="injected!=undefined"
            size="lg"
            class="my-2 my-sm-0 p-3 flex-fill"
            @click="dune_client_refund()"
            variant="warning">
            Use client
          </b-button>
        </template>
      </template>

    </div>


  </form>
  <b-modal
    :header-bg-variant="get_variant()"
    :header-text-variant="get_text('')"
    :body-bg-variant="get_variant()"
    :body-text-variant="get_text('')"
    :footer-bg-variant="get_variant()"
    :footer-text-variant="get_text('')"
    id="modal-deposit"
    title="Deposit">
    <p>
      This entry point can be called by anyone who wishes to swap his/her DUN tokens (must be non zero).
    </p>
    <p>
      The user must provide a secret, a return address in case of refund (which is not a smart contract), the address of the contract on Free TON that must be credited in accordance, his/her public key on Free TON.
    </p>
    <ul>
      <li class="font-weight-bold">Amount</li>
      <p class="ml-3">Amount of DUN tokens to be swapped</p>
      <li class="font-weight-bold">Return Address</li>
      <p class="ml-3">
        The Dune Network Address where the deposited DUN tokens will be returned in case of a refund following the expiration of the swap initiated by the deposit
      </p>
      <li class="font-weight-bold">Free TON Address</li>
      <p class="ml-3">
        The Free TON Address where the TON crystals will be sent once the swap is completed
        <b-alert show variant="danger">
          Make sure you own the private key corresponding to this address or you won't be able to access the tokens
        </b-alert>
      </p>
      <li class="font-weight-bold">Free TON Pubkey</li>
      <p class="ml-3">Your public key on Free TON</p>
      <p class="ml-3">
        From Extraton:
        <b-img src="/images/pubkey_extraton.png" fluid alt="Responsive image">
        </b-img>
        <img>
      </p>
      <li class="font-weight-bold">Secret</li>
      <p class="ml-3">
        This secret would be use to finalize the swap
        <b-alert show variant="danger">
          You will need your secret to finalize the swap. Make sure you don't forget it
        </b-alert>
      </p>
    </ul>
  </b-modal>
  <b-modal
    :header-bg-variant="get_variant()"
    :header-text-variant="get_text('')"
    :body-bg-variant="get_variant()"
    :body-text-variant="get_text('')"
    :footer-bg-variant="get_variant()"
    :footer-text-variant="get_text('')"
    id="modal-swap"
    title="Reveal">
    <p>
      In order to credit the smart contrat on FreeTon chain the secret needs to be revealed.
    </p>
    <ul>
      <li class="font-weight-bold">Secret</li>
      <p class="ml-3">
        This is the secret used during the deposit stage
      </p>
    </ul>

  </b-modal>
</div>
